package com.mycompany.webservice;

/*
 *-------------------------------------------------------------------
 * IBM Confidential
 * OCO Source Materials
 *
 * WebSphere Commerce
 *
 * (c) Copyright International Business Machines Corporation.
 *     2006
 *     All rights reserved.
 *
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of what has been
 * deposited with the US Copyright Office.
 *-------------------------------------------------------------------
 */

import java.io.InputStream;
import java.net.URL;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.soap.MessageFactory;
import javax.xml.soap.MimeHeaders;
import javax.xml.soap.SOAPBody;
import javax.xml.soap.SOAPConnection;
import javax.xml.soap.SOAPConnectionFactory;
import javax.xml.soap.SOAPMessage;

import org.w3c.dom.Document;


/**
 * Same java application to test the SyncCustomer using the SAAJ to make the
 * web service and a text file that contains the input to the web service.
 * The input file is in the same package as the application and is 
 * loaded as a resource by the class loader.
 */
public class SyncCustomerTest {
	public static void main(String[] args) {
		
		try {
			String url = "http://localhost:81/webapp/wcs/services/CustomerServices";
			InputStream inputStream = Thread.currentThread().getContextClassLoader()
										.getResourceAsStream("com/mycompany/webservice/input.xml");
			
			MessageFactory mf = MessageFactory.newInstance();
			SOAPMessage msg = mf.createMessage();
			
	        // Add a SoapAction header
	        MimeHeaders hd = msg.getMimeHeaders();
	        hd.addHeader("SOAPAction", "http://localhost:81/webapp/wcs/services/CustomerServices");

			SOAPBody body = msg.getSOAPPart().getEnvelope().getBody();
			DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
			dbf.setNamespaceAware(true);
			DocumentBuilder db = dbf.newDocumentBuilder();
			Document doc = db.parse(inputStream);
			body.addDocument(doc);
			
			SOAPConnection conn = SOAPConnectionFactory.newInstance().createConnection();
			SOAPMessage resp = conn.call(msg, new URL(url));
			
			System.out.println(resp.getSOAPBody());
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
